/**
 * Copyright (C) 2011 Agrosense <info@cloudfarming.nl>
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain a
 * copy of the License at
 *
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package nl.cloudfarming.client.isobus.type;

import java.util.List;
import nl.cloudfarming.client.isobus.model.DeviceAllocation;
import org.openide.nodes.ChildFactory;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.NbBundle;
import org.openide.util.NbBundle.Messages;

/**
 *
 * @author Gerben Feenstra
 */
@Messages("isobus.project.taskdata.node.name.allocationstamp=AllocationStamp ({0} - {1})")
public class DeviceAllocationChildFactory extends ChildFactory<Node> {
    
    private static final String ALLOCATIONSTAMP_NODE_ICON = "";
    private final DeviceAllocation deviceAllocation;

    public DeviceAllocationChildFactory(DeviceAllocation deviceAllocation) {
        this.deviceAllocation = deviceAllocation;
    }
    
    @Override
    protected boolean createKeys(List<Node> toPopulate) {
        String displayName = NbBundle.getMessage(DeviceAllocationChildFactory.class, "isobus.project.taskdata.node.name.allocationstamp");
    
        //AllocationStamp (ASP)
        toPopulate.add(new IsobusCommonNode(Children.LEAF, deviceAllocation.getAllocationStamp(), ALLOCATIONSTAMP_NODE_ICON, displayName)); 
        return true;
    }

    @Override
    protected Node createNodeForKey(Node node) {
        return node;
    }
}
