/**
 * Copyright (C) 2011 Agrosense <info@cloudfarming.nl>
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain a
 * copy of the License at
 *
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package nl.cloudfarming.client.isobus.type;

import java.util.List;
import nl.cloudfarming.client.isobus.model.DeviceElement;
import nl.cloudfarming.client.isobus.model.DeviceObjectReference;
import org.openide.nodes.ChildFactory;
import org.openide.nodes.Children;
import org.openide.nodes.Node;
import org.openide.util.NbBundle;
import org.openide.util.NbBundle.Messages;

/**
 *
 * @author Gerben Feenstra
 */
@Messages("isobus.project.taskdata.node.name.deviceobjectreference=DeviceObjectReference ({0} - {1})")
public class DeviceElementChildFactory extends ChildFactory<DeviceObjectReference> {

    private static final String DEVICEOBJECTREFERENCE_NODE_ICON = "";
    private final DeviceElement deviceElement;

    public DeviceElementChildFactory(DeviceElement deviceElement) {
        this.deviceElement = deviceElement;
    }
    
    @Override
    protected boolean createKeys(List<DeviceObjectReference> toPopulate) {
        toPopulate.addAll(deviceElement.getDeviceObjectReferences());
        return true;
    }

    @Override
    protected Node createNodeForKey(DeviceObjectReference deviceObjectReference) {
        String displayName = NbBundle.getMessage(DeviceElementChildFactory.class, "isobus.project.taskdata.node.name.deviceobjectreference");   
        return new IsobusCommonNode(Children.LEAF, deviceObjectReference, DEVICEOBJECTREFERENCE_NODE_ICON, displayName);
    }
}
